.586    
.model flat,stdcall
option casemap:none

WinMain PROTO   :DWORD,:DWORD,:DWORD,:DWORD

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib

.const

MainWindowWidth     equ     600
MainWindowHeight    equ     350

PopupWidth		equ		450
PopupHeight		equ		300


.data

hInstance       dd      ?
hMainWindow     dd      ?
MainWindowClass db      'MainWindowClass',0
MainWindowName  db      'Pipe Example',0

wc          WNDCLASSEX  <sizeof wc,CS_HREDRAW+CS_VREDRAW,offset WndProc,NULL,NULL,NULL, \
                        NULL,NULL,COLOR_WINDOW,NULL,offset MainWindowClass,NULL>

; ++++ Edit related +++++
                        
EditClass       db      'EDIT',0
hEdit           dd          ?

; ++++ Static related +++++

StaticClass     db      'STATIC',0
hStatic         dd          ?

; ++++ Others +++++
                        
szProcess		db		'.\p.exe',0
szPipe			db		'\\.\pipe\mypipe',0
hPipe			dd		?
rect            RECT        <>
EdStream        EDITSTREAM      <>
StreamError     dd              ?
ErrorPipeCreate db      'Couldnt create Pipe',0
                        
.code
    start:
        invoke  GetModuleHandle,NULL
        mov hInstance,eax
        invoke  WinMain,hInstance,NULL,NULL,SW_SHOWNORMAL
        invoke  ExitProcess,eax

WinMain PROC    hInst:DWORD,hPInst:DWORD,CmdLine:DWORD,CmdShow:DWORD

    local   msg:MSG

    push    hInstance
    pop     wc.hInstance
    invoke  LoadIcon,NULL,IDI_APPLICATION
    mov     wc.hIcon,eax
    mov     wc.hIconSm,eax
    invoke  LoadCursor,NULL,IDC_ARROW
    mov     wc.hCursor,eax
    invoke  RegisterClassEx,addr wc
    invoke  GetSystemMetrics,SM_CYSCREEN
    shr     eax,1
    sub     eax,MainWindowHeight/2
    push    eax
    invoke  GetSystemMetrics,SM_CXSCREEN
    shr     eax,1
    sub     eax,MainWindowWidth
    pop     ebx
    invoke  CreateWindowEx,NULL,addr MainWindowClass,addr MainWindowName,WS_TILEDWINDOW,\   
               eax,ebx,MainWindowWidth,MainWindowHeight,NULL,NULL,hInstance,NULL
    mov     hMainWindow,eax
    invoke  ShowWindow,eax,CmdShow
    invoke  UpdateWindow,hMainWindow

msg_loop:
    invoke  GetMessage,addr msg,NULL,0,0
    or      eax,eax
    jz      end_msg_loop
    invoke  TranslateMessage,addr msg
    invoke  DispatchMessage,addr msg
    jmp     msg_loop
end_msg_loop:
    mov     eax,msg.wParam
    ret

WinMain     endp

WndProc PROC    hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

	local		stinfo:STARTUPINFO,pi:PROCESS_INFORMATION,hProcess:DWORD
	
    .if uMsg==WM_DESTROY
        invoke  OpenProcess,PROCESS_TERMINATE,FALSE,pi.dwProcessId
        mov     hProcess,eax
        invoke  TerminateProcess,eax,NULL
        invoke  CloseHandle,hProcess
        invoke  PostQuitMessage,NULL
	.elseif 	uMsg==WM_CREATE
		mov		edi,lParam
		.if		[edi.CREATESTRUCT].hWndParent==NULL
                invoke  GetClientRect,hWnd,addr rect
                sub     rect.bottom,22
                invoke  CreateWindowEx,WS_EX_STATICEDGE,addr EditClass,NULL,WS_VISIBLE+WS_CHILD+ES_MULTILINE+ES_WANTRETURN,\
                                0,0,rect.right,rect.bottom,hWnd,NULL,hInstance,NULL
                mov     hEdit,eax
                push    rect.bottom
                pop     rect.top
                invoke  CreateWindowEx,WS_EX_STATICEDGE,addr StaticClass,NULL,WS_VISIBLE+WS_CHILD+SS_SIMPLE,\
                        rect.left,rect.top,rect.right,20,hWnd,NULL,hInstance,NULL
                mov     hStatic,eax           
                mov     stinfo.cb,sizeof stinfo             
			invoke	GetStartupInfo,addr stinfo
                  mov         stinfo.dwFlags,STARTF_USESHOWWINDOW+STARTF_USESTDHANDLES
			mov		stinfo.wShowWindow,SW_SHOWNORMAL
			invoke	CreateNamedPipe,addr szPipe,PIPE_ACCESS_DUPLEX+FILE_FLAG_WRITE_THROUGH,PIPE_TYPE_BYTE+PIPE_READMODE_BYTE+PIPE_NOWAIT,PIPE_UNLIMITED_INSTANCES,\
                                NULL,NULL,NULL,NULL
                .if     eax==INVALID_HANDLE_VALUE
                    invoke  SendMessage,hStatic,WM_SETTEXT,NULL,addr ErrorPipeCreate
                .else    
			mov		hPipe,eax
                invoke  GetStdHandle,STD_OUTPUT_HANDLE
                mov     stinfo.hStdOutput,eax
                mov     stinfo.hStdError,eax
                push    hPipe
                pop     stinfo.hStdInput
            ;    invoke  AllocConsole
			invoke	CreateProcess,addr szProcess,NULL,NULL,NULL,TRUE,CREATE_DEFAULT_ERROR_MODE+NORMAL_PRIORITY_CLASS,\
                                NULL,NULL,addr stinfo,addr pi
                .endif
		.endif
    .elseif uMsg==WM_CHAR
        invoke  ConnectNamedPipe,hPipe,NULL
        mov     EdStream.dwCookie,NULL
        mov     EdStream.dwError,offset StreamError
        mov     EdStream.pfnCallback,offset StreamOutProc
        invoke  SendMessage,hEdit,EM_STREAMOUT,SF_TEXT,addr EdStream
     ;   invoke  DisconnectNamedPipe,hPipe		        
    .else
        invoke  DefWindowProc,hWnd,uMsg,wParam,lParam
        ret
    .endif
    xor eax,eax
    ret

WndProc     endp

StreamOutProc       PROC        dwCookie:DWORD,lpBuff:DWORD,cb:DWORD,pcb:DWORD

    invoke  WriteFile,hPipe,lpBuff,cb,pcb,NULL
    ret
    
StreamOutProc       endp
end start                                            
