.586    
.model flat,stdcall
option casemap:none

WinMain PROTO   :DWORD,:DWORD,:DWORD,:DWORD

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\comctl32.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\comctl32.lib

.const

MainWindowWidth     equ     600
MainWindowHeight    equ     350

.data

hInstance       dd      ?
hMainWindow     dd      ?
MainWindowClass db      'MainWindowClass',0
MainWindowName  db      '???',0
wc          WNDCLASSEX  <sizeof wc,CS_HREDRAW+CS_VREDRAW,offset WndProc,NULL,NULL,NULL, \
                        NULL,NULL,COLOR_WINDOW,NULL,offset MainWindowClass,NULL>
EditClass       db      'EDIT',0
hEdit           dd          ?
rect            RECT        <>
stinfo          STARTUPINFO	<>
EdStream        EDITSTREAM      <>
Error           dd              ?
lpReadBuffer    db      1024 dup(0)
lpWriteBuffer   db      1024    dup(0)
szPipe			db		'\\.\pipe\mypipe',0
cbOperation     dd      ?      
lpTotal         dd      ?
lpLeft          dd      ?
                        
.code
    start:
        invoke  GetModuleHandle,NULL
        mov hInstance,eax
        invoke  InitCommonControls
        invoke  GetStartupInfo,addr stinfo
        invoke  WinMain,hInstance,NULL,NULL,SW_SHOWNORMAL
        invoke  ExitProcess,eax

WinMain PROC    hInst:DWORD,hPInst:DWORD,CmdLine:DWORD,CmdShow:DWORD

    local   msg:MSG

    push    hInstance
    pop     wc.hInstance
    invoke  LoadIcon,NULL,IDI_APPLICATION
    mov     wc.hIcon,eax
    mov     wc.hIconSm,eax
    invoke  LoadCursor,NULL,IDC_ARROW
    mov     wc.hCursor,eax
    invoke  RegisterClassEx,addr wc
    invoke  GetSystemMetrics,SM_CYSCREEN
    shr     eax,1
    sub     eax,MainWindowHeight/2
    push    eax
    invoke  GetSystemMetrics,SM_CXSCREEN
    shr     eax,1
    pop     ebx
    invoke  CreateWindowEx,WS_EX_TOOLWINDOW,addr MainWindowClass,addr MainWindowName,WS_POPUP,\   
               eax,ebx,MainWindowWidth,MainWindowHeight,NULL,NULL,hInstance,NULL
    mov     hMainWindow,eax
    invoke  ShowWindow,eax,CmdShow
    invoke  UpdateWindow,hMainWindow

msg_loop:
    invoke  PeekMessage,addr msg,NULL,0,0,PM_NOREMOVE
    or      eax,eax
    jz      no_msg
    invoke  GetMessage,addr msg,NULL,0,0
    or      eax,eax
    jz      end_msg_loop
    invoke  TranslateMessage,addr msg
    invoke  DispatchMessage,addr msg
    jmp     msg_loop
no_msg:
        mov     EdStream.dwCookie,NULL
        mov     EdStream.dwError,offset Error                    
        mov     EdStream.pfnCallback,offset StreamInProc
        invoke  SendMessage,hEdit,EM_STREAMIN,SF_TEXT,addr EdStream
        jmp     msg_loop
    
end_msg_loop:
    mov     eax,msg.wParam
    ret

WinMain     endp

WndProc PROC    hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    .if uMsg==WM_DESTROY
        invoke  PostQuitMessage,NULL
    .elseif uMsg==WM_CREATE
        mov     edi,lParam
        .if     [edi.CREATESTRUCT].hWndParent==NULL
            invoke  GetClientRect,hWnd,addr rect
            add     rect.top,2
            add     rect.left,2
            sub     rect.bottom,4
            sub     rect.right,4
            invoke  CreateWindowEx,WS_EX_STATICEDGE,addr EditClass,NULL,WS_VISIBLE+WS_CHILD+ES_MULTILINE,\
                        rect.left,rect.top,rect.right,rect.bottom,hWnd,NULL,hInstance,NULL
            mov     hEdit,eax
        .endif
        
    .else
        invoke  DefWindowProc,hWnd,uMsg,wParam,lParam
        ret
    .endif
    xor eax,eax
    ret

WndProc     endp

StreamInProc     PROC     dwCookie:DWORD,lpBuff:DWORD,cb:DWORD,pcb:DWORD

    invoke  PeekNamedPipe,addr szPipe,lpBuff,cb,pcb,addr lpTotal,addr lpLeft
    ret

StreamInProc        endp

end start                                            
